﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using AsycValidation.Web;

namespace AsycValidation
{
    public class CompanyViewModel : BasicViewModel
    {
        public CompanyModel CompanyModelData { get; set; }

        public CompanyViewModel(CompanyModel model)
        {
            CompanyModelData = model;
        }

        private string _CompanyName = null;
        private const int ACCOUNT_ALREADY_EXIST_ERROCODE = 100;

        DomainService1 service = new DomainService1();

        public string CompanyName
        {
            get
            {
                return _CompanyName;
            }
            set
            {
                if (_CompanyName != value)
                {
                    var propertyName = "CompanyName";

                    ValidateAccountAlreadyExists(
                                    value,
                                    propertyName,
                                    ACCOUNT_ALREADY_EXIST_ERROCODE,
                                    string.Format("Company with the ID {0} already exists", value));

                    _CompanyName = value;
                    NotifyPropertyChanged(propertyName);
                }
            }
        }

        private void ValidateAccountAlreadyExists(
                                        string CompanyID,
                                        string propertyName,
                                        int errorCode,
                                        string errorMsg)
        {
            service.DoesCompanyExists(
                 CompanyID,
                 invokeOperation =>
                 {
                     if (invokeOperation.Value)
                     {
                         AddErrorToPropertyAndNotifyErrorChanges(
                             propertyName,
                             new ValidationErrorInfo()
                             {
                                 ErrorCode = errorCode,
                                 ErrorMessage = errorMsg
                             });
                     }
                     else
                     {
                         RemoveErrorFromPropertyAndNotifyErrorChanges(
                               propertyName,
                               errorCode);
                     }
                 },
                 null);
        }

    }
}
